# StorageSync

> see https://aka.ms/autorest

This is the AutoRest configuration file for StorageSync.



---
## Getting Started
To build the SDK for Storage, simply [Install AutoRest](https://aka.ms/autorest/install) and in this folder, run:

> `autorest`

To see additional help and options, run:

> `autorest --help`
---

## Configuration



### Basic Information
These are the global settings for the Storage Sync API.

``` yaml
openapi-type: arm
tag: package-2018-07-01
```



### Tag: package-2018-10-01

These settings apply only when `--tag=package-2018-07-01` is specified on the command line.

``` yaml $(tag) == 'package-2018-10-01'
input-file:
- Microsoft.StorageSync/preview/2018-10-01/storagesync.json
```


### Tag: package-2018-07-01

These settings apply only when `--tag=package-2018-07-01` is specified on the command line.

``` yaml $(tag) == 'package-2018-07-01'
input-file:
- Microsoft.StorageSync/stable/2018-07-01/storagesync.json
```


### Tag: package-2018-04-02

These settings apply only when `--tag=package-2018-04-02` is specified on the command line.

``` yaml $(tag) == 'package-2018-04-02'
input-file:
- Microsoft.StorageSync/stable/2018-04-02/storagesync.json
```


### Tag: package-2017-06-05-preview

These settings apply only when `--tag=package-2017-06-05-preview` is specified on the command line.

``` yaml $(tag) == 'package-2017-06-05-preview'
input-file:
- Microsoft.StorageSync/preview/2017-06-05-preview/storagesync.json
```


---
# Code Generation

## Swagger to SDK

This section describes what SDK should be generated by the automatic system.
This is not used by Autorest itself.

``` yaml $(swagger-to-sdk)
swagger-to-sdk:
  - repo: azure-sdk-for-python
  - repo: azure-sdk-for-java
  - repo: azure-sdk-for-go
  - repo: azure-sdk-for-js
  - repo: azure-sdk-for-node
```

## C#

These settings apply only when `--csharp` is specified on the command line.
Please also specify `--csharp-sdks-folder=<path to "SDKs" directory of your azure-sdk-for-net clone>`.

``` yaml $(csharp)
csharp:
  azure-arm: true
  license-header: MICROSOFT_MIT_NO_VERSION
  namespace: Microsoft.Azure.Management.StorageSync
  payload-flattening-threshold: 1
  output-folder: $(csharp-sdks-folder)/StorageSync/Management.StorageSync/Generated
  clear-output-folder: true
```

## Python

These settings apply only when `--python` is specified on the command line.
Please also specify `--python-sdks-folder=<path to the root directory of your azure-sdk-for-python clone>`.
Use `--python-mode=update` if you already have a setup.py and just want to update the code itself.

``` yaml $(python)
python-mode: create
python:
  azure-arm: true
  license-header: MICROSOFT_MIT_NO_VERSION
  payload-flattening-threshold: 2
  namespace: azure.mgmt.storagesync
  package-name: azure-mgmt-storagesync
  package-version: 1.0.0
  clear-output-folder: true
```
``` yaml $(python) && $(python-mode) == 'update'
python:
  no-namespace-folders: true
  output-folder: $(python-sdks-folder)/azure-mgmt-storagesync/azure/mgmt/storagesync
```
``` yaml $(python) && $(python-mode) == 'create'
python:
  basic-setup-py: true
  output-folder: $(python-sdks-folder)/azure-mgmt-storagesync
```

## Go

See configuration in [readme.go.md](./readme.go.md)

## Java

These settings apply only when `--java` is specified on the command line.
Please also specify `--azure-libraries-for-java-folder=<path to the root directory of your azure-libraries-for-java clone>`.

``` yaml $(java)
java:
  azure-arm: true
  fluent: true
  namespace: com.microsoft.azure.management.storagesync
  license-header: MICROSOFT_MIT_NO_CODEGEN
  payload-flattening-threshold: 1
  output-folder: $(azure-libraries-for-java-folder)/azure-mgmt-storagesync
```
